define({
  manifest: {
    "ui/frame": { type: "ui/defaultFrame" },
    "ui/menu": { type: "ui/defaultMenu" },//{type: "install/menu"},//
    "frameAlert": { type: "ui/defaultAlert" },

    //webgis{
    "maps/ui/frame": { type: "maps/ui/frame" },
    "maps/map": { "maps/iMapFrame": "maps/ui/frame" },
    "maps/ui/uiFrame": { "maps/ui/iUiFrame": "maps/ui/frame" },
    "maps/layers/interAction": { map: "maps/map" },
    "maps/layers/gcjmStatisticsUi": { gcjmStatistics: "maps/layers/gcjmStatistics" },
    "maps/mapUi": { map: "maps/map" },
    //}

    //mobile{
    // "ui/mobileFrame": {"ui/defaultContainer": "mobile/ui/defaultContainer"},
    "mobile/frameAlert": { type: "ui/defaultAlert", deps: { "ui/frame": "ui/mobileFrame" } },
    "mobile/maps/tools/layersSetting": { type: "maps/tools/layersSetting", deps: { "maps/map": "mobile/maps/map" } },
    "mobile/maps/map": { type: 'maps/map', deps: { "maps/iMapFrame": "ui/mobileFrame" } },//mobile/maps/ui/frame
    "mobile/maps/layers/interAction": { type: 'maps/layers/interAction', deps: { map: "mobile/maps/map" } },
    'mobile/maps/layers/ships': {
      type: 'maps/layers/ships',
      deps: {
        'maps/map': 'mobile/maps/map',
        "maps/tools/layersSetting": "mobile/maps/tools/layersSetting",
        "frameAlert": "mobile/frameAlert"
      }
    },
    "mobile/maps/layers/thhj": {
      type: "maps/layers/thhj",
      deps: { "maps/map": "mobile/maps/map", "maps/tools/layersSetting": "mobile/maps/tools/layersSetting" }
    },
    "mobile/maps/layers/cctv": {
      type: "maps/layers/cctv",
      deps: { "maps/map": "mobile/maps/map", "maps/tools/layersSetting": "mobile/maps/tools/layersSetting" }
    },
    //}

    //playback{
    "ui/playbackMenu": { type: "ui/defaultMenu" },
    "ui/playbackDefaultContainer": { type: "ui/defaultContainer", deps: "ui/playbackFrame" },
    "maps/ui/playbackFrame": {
      type: "maps/ui/playbackFrame",
      deps: { "ui/menu": "ui/playbackMenu", "ui/defaultContainer": "ui/playbackDefaultContainer" }
    },
    "maps/playbackMap": { type: "maps/map", deps: { "maps/iMapFrame": "maps/ui/playbackFrame" } },
    "maps/ui/playbackUiFrame": { type: "maps/ui/uiFrame", deps: { "maps/ui/iUiFrame": "maps/ui/playbackFrame" } },
    "maps/layers/playbackInterAction": { type: "maps/layers/interAction", deps: { map: "maps/playbackMap" } },
    "maps/playbackMapUi": { type: "maps/mapUi", deps: { map: "maps/playbackMap" } },
    "maps/layers/playback2": { map: "maps/playbackMap", root: "root" },
    "maps/ui/playbackDetailViewer": {
      type: "maps/ui/detailViewer",
      deps: { "maps/map": "maps/playbackMap", "maps/ui/uiFrame": "maps/ui/playbackUiFrame" }
    },
    "maps/layers/playbackUi": {
      frame: "maps/ui/playbackUiFrame",
      playback: "maps/layers/playback2",
      interAction: "maps/layers/playbackInterAction",
      detailViewer: "maps/ui/playbackDetailViewer"
    },
    //}
  },
  pages: {
    index: {
      plugins: [
        'user/info',    //用户信息
        'message',    //用户消息
        'help',    //帮助

        'ui/frame',    //整体框架
        'ui/menu',    //左侧菜单栏
        'user/infoView',     //用户信息UI(右上角用户信息)
      ]
    },
    mobile: {
      default: true,
      mainPlugin: "ui/mobileFrame",
      plugins: [
        'ui/mobileFrame',
        'mobile/maps/map',
        'mobile/maps/layers/interAction',
        'mobile/maps/layers/ships',
        "mobile/maps/layers/thhj",
        // "mobile/maps/layers/cctv"
      ]
    },
    playback: {
      mainPlugin: "maps/ui/playbackFrame",
      plugins: [
        //core （非UI）
        'user/info',    //用户信息
        'message',    //用户消息
        'help',    //帮助
        'ui/playbackMenu',    //左侧菜单栏
        'user/infoView',     //用户信息UI(右上角用户信息)

        'maps/ui/playbackFrame',    //地图页面框架
        'maps/ui/playbackUiFrame',
        'maps/playbackMap',  //地图
        "maps/layers/playbackInterAction",
        'maps/ui/playbackDetailViewer',    //地图详情单
        'maps/layers/playback2',    //回放
        'maps/layers/playbackUi',    //回放Ui
        // 'maps/ui/search',    //地图搜索
        // 'maps/tools/layersSetting',    //
        //'maps/layers/ships',    //船舶
      ],
    },
    install: {
      plugins: [
        'install/collector',

        //core （非UI）
        'maps/map',  //地图
        'maps/layers/plot',  //标绘
        'maps/layers/thhj',  //通航环境
        'maps/layers/taskMembers',  //任务人员（威海）
        'maps/layers/ships',    //船舶
        'maps/layers/playback2',    //回放
        'user/info',    //用户信息
        'message',    //用户消息
        'help',    //帮助
        //}

        //mobile{
        //'maps/iMapFrame:ui/mobileFrame',
        //}

        //webgis{
        'ui/frame',    //整体框架
        'ui/menu',    //左侧菜单栏
        'user/infoView',     //用户信息UI(右上角用户信息)
        // 'fujianUser',    //用户信息（福建）
        'maps/ui/frame',    //地图页面框架
        'maps/ui/detailViewer',    //地图详情单
        'maps/ui/search',    //地图搜索
        'maps/tools/setting',    //地图设置
        'maps/tools/legend',    //地图图例
        'maps/tools/measure',    //地图量算
        'maps/tools/location',    //地图定位
        'maps/layers/interAction',
        'maps/mapUi',   //地图Ui
        'maps/layers/shipsUi',    //船舶UI
        'maps/layers/shipArchive',    //船舶档案
        'maps/layers/plotUi',    //标绘UI
        'maps/layers/thhjUi',    //通航环境UI
        'maps/layers/workView',    //工作区
        'maps/layers/taskMembersUi',    //任务人员（威海）
        'maps/layers/gcjmStatistics',    //观测截面
        'maps/layers/gcjmStatisticsUi',    //观测截面UI

        'maps/layers/taskUi',    //任务列表（威海）
        'maps/layers/cctv',    //CCTV
        'maps/layers/anchorageEvent',    //锚泊事件
        'maps/layers/portShip',    //在港船舶
        'maps/layers/berth',    //泊位
        //'maps/layers/waterDepth',    //水深
        'maps/layers/shipTeam',    //我的船队
        'maps/layers/boxSelectStatistics',    //圈选统计
        'maps/layers/historyRITSQuery',    //智能报警历史查询
        'maps/layers/ritsEvent',    //智能报警
        'maps/layers/specialShip',    //专题船舶
        // }

        //comMis{
        'comMis/userManage',    //用户管理
        //}

        //weihai{
        'weihai/taskManagement',    //任务管理（威海）
        //'weihai/zcData',    //中创数据（威海）
        //}

        //fujian{
        'comMis/cargoShip',    //货船申报（福建）
        'comMis/passengerShip',    //客船申报（福建）
        'comMis/waterWork',    //水工作业（福建）
        'maps/layers/fujianUserManage',    //福建申报用户管理（福建）
        //'maps/layers/fujianWaterWorkView',    //水工作业显示（福建）
        //'maps/layers/shipDeclaration',    //动态申报（福建）
        //}

        //pudong{
        'comMis/VTS',    //船舶动态申报与查询（港口普通用户）（浦东）
        'comMis/VTSMarine',    //船舶动态查询（海事局用户）（浦东）
        //}

        // "playback": [
        // //core
        // 'maps/map',
        // 'maps/layers/plot',
        // 'maps/layers/thhj',
        // 'user/info',
        // //}
        //
        // //mobile{
        // //'maps/iMapFrame:ui/mobileFrame',
        // //}
        //
        // //webgis{
        // 'ui/frame',
        // 'ui/menu',
        // 'user/infoView',
        // 'maps/ui/frame',
        // 'maps/ui/detailViewer',
        // 'maps/ui/search',
        // 'maps/layers/workView',
        // 'maps/layers/playback2',
        // 'maps/layers/interAction',
        'maps/layers/playbackUi',
        // // }
        // ],
      ]
    },
  },
  pageManager: "pageManager",
  values: {
    apiHostIp: appConfig.apiHostIp,//"192.168.9.131",
    apiHostPort: appConfig.apiHostPort,//"9007",
    apiRoot: appConfig.map.apiRoot, //"/wg5"
  },
  plugins: {
    "pageManager": {
      actions: {
        "playback": "maps/layers/playbackUi",
        "shipFocus": "maps/layers/shipsUi"
      }
    },
    "maps/ui/frame": {
      name: 'webgis',
      label: 'Webgis',
      iconFont: 'si-map',
      menuIndex: 1
    },
    "mobile/maps/ui/frame": {
      name: 'mobile',
      label: 'mobile',
      iconFont: 'si-map',
      menuIndex: 1
    },
    "user/info": {
      userConfigData: "api/userConfigData"
    },
    "maps/map": {
      // center: [114.26, 30.56],//武汉
      center: [117.87, 38.96], //天津
      zoom: 10,
      minZoom: 3,
      maxZoom: 18,
      baseLayer: {
        sources: [
          {
            title: 'OpenStreetMap',
            provider: 'ol.source.OSM'
          },
          {
            title: '标准海图',
            provider: 'ol.source.XYZ',
            options: {
              url: $.format("http://${apiHostIp}:${apiHostPort}${apiRoot}/MapService?service=wmts&request=gettile&tilematrixset=advsea&tilematrix={z}&tilerow={y}&tilecol={x}&format=image/png&layer=default&style=default&version=1.0.0")
            }
          },
          {
            default: true,
            title: '基础海图+路图',
            provider: 'ol.source.XYZ',
            options: {
              url: $.format("http://${apiHostIp}:${apiHostPort}${apiRoot}/MapService?service=wmts&request=gettile&tilematrixset=advsearoad&tilematrix={z}&tilerow={y}&tilecol={x}&format=image/png&layer=default&style=default&version=1.0.0")
            }
          }
        ]
      }
    },
    "maps/layers/ships": {

      tileUrl: $.format("http://${apiHostIp}:${apiHostPort}${apiRoot}/api/shiptile/tile"),
      tileVersionUrl: $.format("http://${apiHostIp}:${apiHostPort}${apiRoot}/api/shiptile/tile"),
      rtds: $.format('ws://${apiHostIp}:${apiHostPort}${apiRoot}/api/rtds'),
      shiphistoryApi: $.format("http://${apiHostIp}:${apiHostPort}${apiRoot}/api/shiphistory"),
      signalApi: $.format("http://${apiHostIp}:${apiHostPort}${apiRoot}/api/ships/signal"),
      expires: 60 * 60 * 1,
      zIndex: 1,
      zoom: 3
    },
    "maps/layers/thhj": {
      locationApi: $.format("http://${apiHostIp}:${apiHostPort}${apiRoot}/api/location"),
      defaultTrafficEnvStyleApi: $.format("http://${apiHostIp}:${apiHostPort}${apiRoot}/api/DefaultTrafficEnvStyle"),
      zIndex: 3,
      zoom: 10,
      nameZoom: 13
    },
    "maps/layers/berth": {
      berthApi: $.format("http://${apiHostIp}:${apiHostPort}${apiRoot}/api/berth")
    },
  }
});
