define(["require", "exports"], function (require, exports) {
    "use strict";
    var SearchPlug = (function () {
        function SearchPlug(config) {
            this.providers_ = [];
        }
        Object.defineProperty(SearchPlug.prototype, "providers", {
            get: function () {
                return this.providers_;
            },
            enumerable: true,
            configurable: true
        });
        SearchPlug.prototype.addProvider = function (provider) {
            if (this.providers_.indexOf(provider) < 0)
                return this.providers_.push(provider);
        };
        SearchPlug.prototype.removeProvider = function (provider) {
            var idx = this.providers_.indexOf(provider);
            if (idx >= 0)
                this.providers_.splice(idx, 1);
        };
        return SearchPlug;
    }());
    exports.SearchPlug = SearchPlug;
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.default = SearchPlug;
});
